config/routes.rb
Rails.application.routes.draw do
  resources :bdd_books
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root :to => 'bdd_books#new'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/bdd_book.rb
class BddBook < ApplicationRecord
  validates :title, presence: true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/bdd_books_controller.rb
class BddBooksController < ApplicationController
  before_action :set_bdd_book, only: [:show, :edit, :update, :destroy]

  # GET /bdd_books
  # GET /bdd_books.json
  def index
    @bdd_books = BddBook.all
  end

  # GET /bdd_books/1
  # GET /bdd_books/1.json
  def show
  end

  # GET /bdd_books/new
  def new
    @bdd_book = BddBook.new
  end

  # GET /bdd_books/1/edit
  def edit
  end

  # POST /bdd_books
  # POST /bdd_books.json
  def create
    @bdd_book = BddBook.new(bdd_book_params)

    respond_to do |format|
      if @bdd_book.save
        format.html { redirect_to @bdd_book, notice: 'Bdd book was successfully created.' }
        format.json { render :show, status: :created, location: @bdd_book }
      else
        format.html { render :new }
        format.json { render json: @bdd_book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /bdd_books/1
  # PATCH/PUT /bdd_books/1.json
  def update
    respond_to do |format|
      if @bdd_book.update(bdd_book_params)
        format.html { redirect_to @bdd_book, notice: 'Bdd book was successfully updated.' }
        format.json { render :show, status: :ok, location: @bdd_book }
      else
        format.html { render :edit }
        format.json { render json: @bdd_book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /bdd_books/1
  # DELETE /bdd_books/1.json
  def destroy
    @bdd_book.destroy
    respond_to do |format|
      format.html { redirect_to bdd_books_url, notice: 'Bdd book was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_bdd_book
      @bdd_book = BddBook.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def bdd_book_params
      params.require(:bdd_book).permit(:title, :author, :category, :year)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/bdd_books_helper.rb
module BddBooksHelper
end

app/views/bdd_books/_form.html.erb
<%= form_with(model: bdd_book, local: true) do |form| %>
  <% if bdd_book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(bdd_book.errors.count, "error") %> prohibited this bdd_book from being saved:</h2>

      <ul>
        <% bdd_book.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :author %>
    <%= form.text_field :author %>
  </div>

  <div class="field">
    <%= form.label :category %>
    <%= form.text_field :category %>
  </div>

  <div class="field">
    <%= form.label :year %>
    <%= form.number_field :year %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/bdd_books/edit.html.erb
<h1>Editing Bdd Book</h1>

<%= render 'form', bdd_book: @bdd_book %>

<%= link_to 'Show', @bdd_book %> |
<%= link_to 'Back', bdd_books_path %>

app/views/bdd_books/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Bdd Books</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Author</th>
      <th>Category</th>
      <th>Year</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @bdd_books.each do |bdd_book| %>
      <tr>
        <td><%= bdd_book.title %></td>
        <td><%= bdd_book.author %></td>
        <td><%= bdd_book.category %></td>
        <td><%= bdd_book.year %></td>
        <td><%= link_to 'Show', bdd_book %></td>
        <td><%= link_to 'Edit', edit_bdd_book_path(bdd_book) %></td>
        <td><%= link_to 'Destroy', bdd_book, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Bdd Book', new_bdd_book_path %>

app/views/bdd_books/new.html.erb
<h1>New Bdd Book</h1>

<%= render 'form', bdd_book: @bdd_book %>

<%= link_to 'Back', bdd_books_path %>

app/views/bdd_books/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @bdd_book.title %>
</p>

<p>
  <strong>Author:</strong>
  <%= @bdd_book.author %>
</p>

<p>
  <strong>Category:</strong>
  <%= @bdd_book.category %>
</p>

<p>
  <strong>Year:</strong>
  <%= @bdd_book.year %>
</p>

<%= link_to 'Edit', edit_bdd_book_path(@bdd_book) %> |
<%= link_to 'Back', bdd_books_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>BddProba</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/people/_form.html.erb
<%= form_with(model: person, local: true) do |form| %>
  <% if person.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(person.errors.count, "error") %> prohibited this person from being saved:</h2>

      <ul>
        <% person.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

    <%= form.label :name %>
    <%= form.text_field :name %>

    <%= form.label :age %>
    <%= form.text_field :age %>

    <%= form.label :gender %>
    <%= form.text_field :gender %>

    <%= form.submit %>
<% end %>

app/views/people/edit.html.erb
<h1>Editing Person</h1>

<%= render 'form', person: @person %>

<%= link_to 'Show', @person %> |
<%= link_to 'Back', people_path %>

app/views/people/index.html.erb
<p id="notice"><%= notice %></p>

<h1>People</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Age</th>
      <th>Gender</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @people.each do |person| %>
      <tr>
        <td><%= person.name %></td>
        <td><%= person.age %></td>
        <td><%= person.gender %></td>
        <td><%= link_to 'Show', person %></td>
        <td><%= link_to 'Edit', edit_person_path(person) %></td>
        <td><%= link_to 'Destroy', person, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Person', new_person_path %>

app/views/people/new.html.erb
<h1>New Person</h1>

<%= render 'form', person: @person %>

<%= link_to 'Back', people_path %>

app/views/people/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @person.name %>
</p>

<p>
  <strong>Age:</strong>
  <%= @person.age %>
</p>

<p>
  <strong>Gender:</strong>
  <%= @person.gender %>
</p>

<%= link_to 'Edit', edit_person_path(@person) %> |
<%= link_to 'Back', people_path %>